/******************************************************************************
 *
 * Copyright (C) 1996-2001 Jason Evans <jasone@canonware.com>.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice(s), this list of conditions and the following disclaimer as
 *    the first lines of this file unmodified other than the possible
 *    addition of one or more copyright notices.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice(s), this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER(S) ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT HOLDER(S) BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ******************************************************************************
 *
 * Version: 1.2.0
 *
 ******************************************************************************/

/* Pseudo-opaque type. */
typedef struct cw_res_s cw_res_t;

struct cw_res_s {
	cw_mem_t	*mem;
	cw_bool_t	is_malloced;
	cw_rwl_t	rw_lock;
	cw_dch_t	hash;
	FILE		*fd;
	char		*str;
};

cw_res_t	*res_new(cw_res_t *a_res, cw_mem_t *a_mem);
void		res_delete(cw_res_t *a_res);
void		res_clear(cw_res_t *a_res);
cw_bool_t	res_is_equal(cw_res_t *a_a, cw_res_t *a_b);
cw_bool_t	res_file_merge(cw_res_t *a_res, const char *a_filename);
cw_bool_t	res_list_merge(cw_res_t *a_res,...);
const char	*res_res_val_get(cw_res_t *a_res, const char *a_res_name);
cw_bool_t	res_res_extract(cw_res_t *a_res, const char *a_res_key, char
    **r_res_name, char **r_res_val);
cw_bool_t	res_dump(cw_res_t *a_res, const char *a_filename);
